namespace InfiniTec.Data
{
    /// <summary>
    /// Defines the status for a property
    /// </summary>
    public enum PropertyStatus
    {
        /// <summary>
        /// No status assigned
        /// </summary>
        None = 0,
        /// <summary>
        /// The property status is ok
        /// </summary>
        Ok,
        /// <summary>
        /// The property was not found
        /// </summary>
        NotFound,
        /// <summary>
        /// Access to the property is prohibited
        /// </summary>
        NotAuthorized,
        /// <summary>
        /// The property cannot be accessed due to an unknown error
        /// </summary>
        Unknown = -1
    }
}
