using System;

namespace InfiniTec.Diagnostics
{
	public class TraceOperation: IDisposable
	{
		internal TraceOperation(Trace trace, object id)
		{
			if (trace == null) throw new ArgumentNullException("trace");
			if (id == null) throw new ArgumentNullException("id");

			System.Diagnostics.Trace.CorrelationManager.StartLogicalOperation(id);
		}

		public void Stop()
		{
			((IDisposable) this).Dispose();
		}

		void IDisposable.Dispose()
		{
			System.Diagnostics.Trace.CorrelationManager.StopLogicalOperation();
		}
	}
}