using System;
using System.Collections.Generic;
using System.Text;
using InfiniTec.Data;

namespace InfiniTec.Expressions
{
    public class OrExpression: OperatorExpression
    {
          public OrExpression(params Expression[] expressions):
            this((IEnumerable<Expression>)expressions) { }

        public OrExpression(IEnumerable<Expression> expressions)
            : base(expressions)
        {
        }

        public override bool Evaluate(PropertyCollection properties)
        {
            foreach (Expression expression in Expressions)
            {
                if (expression.Evaluate(properties)) return true;
            }

            return false;
        }
    }
}
