using System;
using System.Runtime.InteropServices;
using Microsoft.Win32.SafeHandles;

namespace InfiniTec.IO
{
	static class SafeNativeMethods
	{
		[DllImport("Kernel32.dll", SetLastError = true)]
		public static extern MemoryMappedFileSafeHandle CreateFileMapping(
			SafeFileHandle hFile,
			IntPtr securityAttributes,
			uint flProtect,
			uint dwMaximumSizeHigh,
			uint dwMaximumSizeLow,
			string lpName);

		[DllImport("Kernel32.dll", SetLastError = true)]
		public static extern bool CloseHandle(IntPtr handle);

		[DllImport("Kernel32.dll", SetLastError = true)]
		public static extern IntPtr MapViewOfFile(
			MemoryMappedFileSafeHandle hFileMappingObject,
			FileMapAccesses dwDesiredAccess,
			uint dwFileOffsetHigh,
			uint dwFileOffsetLow,
			uint dwNumberOfBytesToMap);

		[DllImport("Kernel32.dll", SetLastError = true)]
		public static extern void UnmapViewOfFile(IntPtr lpBaseAddress);
	}

	internal enum FileProtection : uint
	{
		Readonly = 0x2,
		ReadWrite = 0x4,
		WriteCopy = 0x8,
		ExecuteRead = 0x20,
		ExecuteReadWrite = 0x40
	}
	internal enum FileOptions : uint
	{
		Commit = 0x8000000,
		Image = 0x1000000,
		LargePages = 0x80000000,
		NoCache = 0x10000000,
		Reserve = 0x4000000,
	}
}