using System;
using System.Collections.Generic;
using System.Text;

namespace InfiniTec.Security
{
    /// <summary>
    /// Represents the various states of a privilege held by an access token.
    /// </summary>
    public enum PrivilegeState
    {
        /// <summary>
        /// The privilege is held by the token, but disabled
        /// </summary>
        Disable = 0x0,
        /// <summary>
        /// The privilege is enabled.
        /// </summary>
        Enable = 0x2,
        /// <summary>
        /// The privilege is enabled by default.
        /// </summary>
        EnableByDefault = 0x3,
        /// <summary>
        /// The privilege shall be permanently removed from the token.
        /// </summary>
        Remove = 0x4
    }
}
