namespace InfiniTec.Threading
{
    public class OperationProgress: OperationAction
    {
        private readonly object _Status;
        private readonly int _ProgressPercentage;

        public object Status { get { return _Status; } }
        public int ProgressPercentage { get { return _ProgressPercentage; } }

        public OperationProgress(object status) : this(status, 0)
        {
        }

        public OperationProgress(object status, int progressPercentage)
        {
            _Status = status;
            _ProgressPercentage = progressPercentage;
        }
    }
}