﻿using System;
using System.Collections.Generic;
using System.Text;

namespace InfiniTec.Threading
{
	public class WaitAction: OperationAction
	{
		private readonly DateTime _WaitUntil;

		public DateTime WaitUntil
		{
			get { return _WaitUntil; }
		}

		public WaitAction(TimeSpan timeout)
		{
			if (timeout < TimeSpan.Zero) throw new ArgumentOutOfRangeException("timeout", timeout, "The specified timespan must be greater than zero");

			_WaitUntil = DateTime.Now + timeout;
		}

		public WaitAction(DateTime waitUntil)
		{
			_WaitUntil = waitUntil;
		}
	}
}
