using System.Threading;

namespace InfiniTec.Threading
{
    public class WaitForHandleOperation: OperationProgress
    {
        private readonly WaitHandle _WaitHandle;


        public WaitForHandleOperation(WaitHandle waitHandle) : this(waitHandle, null, 0)
        {
        }

        public WaitForHandleOperation(WaitHandle waitHandle, object status) : this(waitHandle, status, 0)
        {
        }

        public WaitForHandleOperation(WaitHandle waitHandle, object status, int progressPercentage): base(status, progressPercentage)
        {
            _WaitHandle = waitHandle;
        }

        public WaitHandle WaitHandle { get { return _WaitHandle; } }
    }
}