﻿using System;
using System.Collections;
using System.Configuration.Install;
using System.Net;

namespace InfiniTec.Exchange.Eventing
{
	public class EventSinkInstaller<T> : Installer
		where T: EventSink
	{
		public NetworkCredential Credential { get; set; }

		public string Criteria { get; set; }

		public EventMethods EventMethods { get; set; }

		public bool IsEnabled { get; set; }

		public int Priority { get; set; }

		public MatchScope? Scope { get; set; }

		public string Url { get; set; }


		public EventSinkInstaller()
		{
			IsEnabled = true;
			Priority = EventRegistration.DefaultPriority;
		}

		public override void Install(IDictionary stateSaver)
		{
			base.Install(stateSaver);

			var registration = EventRegistration.Create(Url, Credential);
			registration.Criteria = Criteria;
			registration.IsEnabled = IsEnabled;
			registration.EventMethods = EventMethods;
			registration.Priority = Priority;
			registration.Scope = Scope;

			registration.SetSinkClassFromType<T>();

			registration.Save();
		}

		public override void Uninstall(IDictionary savedState)
		{
			base.Uninstall(savedState);

			EventRegistration.Delete(Url, Credential);
		}
	}
}