﻿using System;
using System.Configuration;

namespace InfiniTec.Exchange.Eventing
{
    public class EventingConfigurationSection: ConfigurationSection
    {
        private static EventingConfigurationSection _Configuration = (EventingConfigurationSection) ConfigurationManager.GetSection(ConfigurationSectionName);
        private const string ConfigurationSectionName = "infinitec.exchange.eventing";


        public static EventingConfigurationSection Configuration
        {
            get
            {
                if (_Configuration == null)
                {
                    _Configuration = new EventingConfigurationSection();
                }
                return _Configuration;
            }
        }

        public static EventingConfigurationSection GetConfiguration(Configuration configuration)
        {
            if (configuration == null) throw new ArgumentNullException("configuration");

            return (EventingConfigurationSection)configuration.GetSection(ConfigurationSectionName);
        }

        [ConfigurationProperty("jobProcessing")]
        public JobProcessingElement JobProcessing
        {
            get { return (JobProcessingElement) this["jobProcessing"]; }
            set { this["jobProcessing"] = value; }
        }


    }
}