﻿using System;
using System.Runtime.CompilerServices;
using System.Runtime.InteropServices;

namespace InfiniTec.Exchange.Eventing.Interop
{
	[StructLayout(LayoutKind.Sequential, Pack=4), ComConversionLoss]
	public struct _SID
	{
		public byte Revision;
		public byte SubAuthorityCount;
		public _SID_IDENTIFIER_AUTHORITY IdentifierAuthority;
		[ComConversionLoss]
		public IntPtr SubAuthority;
	}

	[StructLayout(LayoutKind.Sequential, Pack=1)]
	public struct _SID_IDENTIFIER_AUTHORITY
	{
		[MarshalAs(UnmanagedType.ByValArray, SizeConst=6)]
		public byte[] Value;
	}

	[Flags]
	public enum EventFlags
	{
		EVT_COPY = 0x200,
		EVT_DRAFT_CHECKIN = 0x1000,
		EVT_DRAFT_CREATE = 0x400,
		EVT_DRAFT_SAVE = 0x800,
		EVT_ERROR = -2147483648,
		EVT_HARDDELETE = 0x20,
		EVT_INITNEW = 0x40,
		EVT_INVALID_SOURCE_URL = 0x20000000,
		EVT_INVALID_URL = 0x40000000,
		EVT_IS_COLLECTION = 2,
		EVT_IS_DELIVERED = 8,
		EVT_LOCK_TRANSIENT = 0x2000,
		EVT_LOCKDEPTH_DEEP = 0x800000,
		EVT_LOCKSCOPE_EXCLUSIVE = 0x100000,
		EVT_LOCKSCOPE_SHARED = 0x80000,
		EVT_LOCKTYPE_CHECKOUT = 0x40000,
		EVT_LOCKTYPE_READ = 0x10000,
		EVT_LOCKTYPE_READWRITE = 0x30000,
		EVT_LOCKTYPE_WRITE = 0x20000,
		EVT_MOVE = 0x100,
		EVT_NEW_ITEM = 1,
		EVT_REPLICATED_ITEM = 4,
		EVT_SOFTDELETE = 0x10,
		EVT_SYNC_ABORTED = 0x4000000,
		EVT_SYNC_BEGIN = 0x1000000,
		EVT_SYNC_COMMITTED = 0x2000000,
		EVT_UNLOCK_CHECKIN_ABORT = 0x200000,
		EVT_UNLOCK_CHECKIN_KEEP_LOCKED = 0x400000,
		EVT_VIRUS_CLEANED = 0x4000
	}

	[ComImport, CoClass(typeof(ExoledbUrlMapperClass)), Guid("9DA0E11D-86CE-11D1-8699-00C04FB98036")]
	public interface ExoledbUrlMapper : IExoledbUrlMapper
	{
	}

	[ComImport, Guid("9DA0E11E-86CE-11D1-8699-00C04FB98036"), TypeLibType((short) 2), ClassInterface((short) 0)]
	public class ExoledbUrlMapperClass : ExoledbUrlMapper
	{
		// Methods
		[return: MarshalAs(UnmanagedType.BStr)]
		[MethodImpl(MethodImplOptions.InternalCall, MethodCodeType=MethodCodeType.Runtime), DispId(0x60020003)]
		public virtual extern string ExoledbFileUrlToFilePath([In, MarshalAs(UnmanagedType.BStr)] string bstrExoledbFileUrl);
		[return: MarshalAs(UnmanagedType.BStr)]
		[MethodImpl(MethodImplOptions.InternalCall, MethodCodeType=MethodCodeType.Runtime), DispId(0x60020002)]
		public virtual extern string FilePathToExoledbFileUrl([In, MarshalAs(UnmanagedType.BStr)] string bstrFilePath);
		[return: MarshalAs(UnmanagedType.SafeArray, SafeArraySubType=VarEnum.VT_VARIANT)]
		[MethodImpl(MethodImplOptions.InternalCall, MethodCodeType=MethodCodeType.Runtime), DispId(0x60020001)]
		public virtual extern object[] FilePathToHttpUrls([In, MarshalAs(UnmanagedType.BStr)] string bstrFilePath);
		[return: MarshalAs(UnmanagedType.BStr)]
		[MethodImpl(MethodImplOptions.InternalCall, MethodCodeType=MethodCodeType.Runtime), DispId(0x60020000)]
		public virtual extern string HttpUrlToFilePath([In, MarshalAs(UnmanagedType.BStr)] string bstrHttpUrl);
	}

	[ComImport, Guid("9DA0E11C-86CE-11D1-8699-00C04FB98036"), InterfaceType((short) 1)]
	public interface ICreateRegistration
	{
		[MethodImpl(MethodImplOptions.InternalCall, MethodCodeType=MethodCodeType.Runtime)]
		int Register([In, MarshalAs(UnmanagedType.Interface)] IExStoreEventInfo pEventInfo, [In, MarshalAs(UnmanagedType.BStr)] string bstrURLItem, [In] EventFlags lFlags);
	}

	[ComImport, Guid("9DA0E11D-86CE-11D1-8699-00C04FB98036"), TypeLibType((short) 0x1040)]
	public interface IExoledbUrlMapper
	{
		[return: MarshalAs(UnmanagedType.BStr)]
		[MethodImpl(MethodImplOptions.InternalCall, MethodCodeType=MethodCodeType.Runtime), DispId(0x60020000)]
		string HttpUrlToFilePath([In, MarshalAs(UnmanagedType.BStr)] string bstrHttpUrl);
		[return: MarshalAs(UnmanagedType.SafeArray, SafeArraySubType=VarEnum.VT_VARIANT)]
		[MethodImpl(MethodImplOptions.InternalCall, MethodCodeType=MethodCodeType.Runtime), DispId(0x60020001)]
		object[] FilePathToHttpUrls([In, MarshalAs(UnmanagedType.BStr)] string bstrFilePath);
		[return: MarshalAs(UnmanagedType.BStr)]
		[MethodImpl(MethodImplOptions.InternalCall, MethodCodeType=MethodCodeType.Runtime), DispId(0x60020002)]
		string FilePathToExoledbFileUrl([In, MarshalAs(UnmanagedType.BStr)] string bstrFilePath);
		[return: MarshalAs(UnmanagedType.BStr)]
		[MethodImpl(MethodImplOptions.InternalCall, MethodCodeType=MethodCodeType.Runtime), DispId(0x60020003)]
		string ExoledbFileUrlToFilePath([In, MarshalAs(UnmanagedType.BStr)] string bstrExoledbFileUrl);
	}

	[ComImport, Guid("9DA0E0FE-86CE-11D1-8699-00C04FB98036"), InterfaceType((short) 1)]
	public interface IExStoreAsyncEvents
	{
		[MethodImpl(MethodImplOptions.InternalCall, MethodCodeType=MethodCodeType.Runtime)]
		void OnSave([In, MarshalAs(UnmanagedType.Interface)] IExStoreEventInfo pEventInfo, [In, MarshalAs(UnmanagedType.BStr)] string bstrURLItem, [In] EventFlags lFlags);
		[MethodImpl(MethodImplOptions.InternalCall, MethodCodeType=MethodCodeType.Runtime)]
		void OnDelete([In, MarshalAs(UnmanagedType.Interface)] IExStoreEventInfo pEventInfo, [In, MarshalAs(UnmanagedType.BStr)] string bstrURLItem, [In] EventFlags lFlags);
	}

	[ComImport, TypeLibType((short) 0x1040), Guid("9DA0E110-86CE-11D1-8699-00C04FB98036")]
	public interface IExStoreDispEventInfo
	{
		[DispId(0x60020000)]
		object EventConnection { [return: MarshalAs(UnmanagedType.IDispatch)] [MethodImpl(MethodImplOptions.InternalCall, MethodCodeType=MethodCodeType.Runtime), DispId(0x60020000)] get; }
		[DispId(0x60020001)]
		object EventRecord { [return: MarshalAs(UnmanagedType.IDispatch)] [MethodImpl(MethodImplOptions.InternalCall, MethodCodeType=MethodCodeType.Runtime), DispId(0x60020001)] get; }
		[MethodImpl(MethodImplOptions.InternalCall, MethodCodeType=MethodCodeType.Runtime), DispId(0x60020002)]
		void AbortChange([In, Optional, DefaultParameterValue(0)] int lErrorCode);
		[DispId(0x60020003)]
		string SourceURL { [return: MarshalAs(UnmanagedType.BStr)] [MethodImpl(MethodImplOptions.InternalCall, MethodCodeType=MethodCodeType.Runtime), DispId(0x60020003)] get; }
		[DispId(0x60020004)]
		string UserGuid { [return: MarshalAs(UnmanagedType.BStr)] [MethodImpl(MethodImplOptions.InternalCall, MethodCodeType=MethodCodeType.Runtime), DispId(0x60020004)] get; }
		[DispId(0x60020005)]
		string StoreGuid { [return: MarshalAs(UnmanagedType.BStr)] [MethodImpl(MethodImplOptions.InternalCall, MethodCodeType=MethodCodeType.Runtime), DispId(0x60020005)] get; }
		[DispId(0x60020006)]
		object UserSid { [return: MarshalAs(UnmanagedType.Struct)] [MethodImpl(MethodImplOptions.InternalCall, MethodCodeType=MethodCodeType.Runtime), DispId(0x60020006)] get; }
		[ComAliasName("Microsoft.Interop.ExOleDB.LONG_PTR"), DispId(0x60020007)]
		IntPtr Data { [return: ComAliasName("Microsoft.Interop.ExOleDB.LONG_PTR")] [MethodImpl(MethodImplOptions.InternalCall, MethodCodeType=MethodCodeType.Runtime), DispId(0x60020007)] get; [param: In, ComAliasName("Microsoft.Interop.ExOleDB.LONG_PTR")] [MethodImpl(MethodImplOptions.InternalCall, MethodCodeType=MethodCodeType.Runtime), DispId(0x60020007)] set; }
	}

	[ComImport, Guid("9DA0E100-86CE-11D1-8699-00C04FB98036"), InterfaceType((short) 1)]
	public interface IExStoreEventInfo
	{
		[MethodImpl(MethodImplOptions.InternalCall, MethodCodeType=MethodCodeType.Runtime)]
		void RemoteGetEventItem([In] ref Guid riid, out uint pdwBindStatus, [MarshalAs(UnmanagedType.IUnknown)] out object ppunkEventItem);
		[MethodImpl(MethodImplOptions.InternalCall, MethodCodeType=MethodCodeType.Runtime)]
		void RemoteGetEventSession([In] ref Guid riid, [MarshalAs(UnmanagedType.IUnknown)] out object ppSession);
		[MethodImpl(MethodImplOptions.InternalCall, MethodCodeType=MethodCodeType.Runtime)]
		void Abort([In, Optional, DefaultParameterValue(0)] int lErrorCode);
	}

	[ComImport, InterfaceType((short) 1), Guid("9DA0E111-86CE-11D1-8699-00C04FB98036"), ComConversionLoss]
	public interface IExStoreEventLogonInfo
	{
		[MethodImpl(MethodImplOptions.InternalCall, MethodCodeType=MethodCodeType.Runtime)]
		void GetUserGuid([In, Out] ref Guid pguid);
		[MethodImpl(MethodImplOptions.InternalCall, MethodCodeType=MethodCodeType.Runtime)]
		void GetStoreGuid([In, Out] ref Guid pguid);
		[MethodImpl(MethodImplOptions.InternalCall, MethodCodeType=MethodCodeType.Runtime)]
		void GetUserSid([Out] IntPtr ppsid);
	}

	[ComImport, Guid("9DA0E117-86CE-11D1-8699-00C04FB98036"), TypeLibType((short) 0x1040)]
	public interface IExStoreEventRegistrationURL
	{
		[DispId(0x60020000)]
		string EventRegistrationURL { [return: MarshalAs(UnmanagedType.BStr)] [MethodImpl(MethodImplOptions.InternalCall, MethodCodeType=MethodCodeType.Runtime), DispId(0x60020000)] get; }
	}

	[ComImport, InterfaceType((short) 1), Guid("9DA0E10E-86CE-11D1-8699-00C04FB98036")]
	public interface IExStoreLockEvents
	{
		[MethodImpl(MethodImplOptions.InternalCall, MethodCodeType=MethodCodeType.Runtime)]
		void OnSyncLock([In, MarshalAs(UnmanagedType.Interface)] IExStoreEventInfo pEventInfo, [In, MarshalAs(UnmanagedType.BStr)] string bstrURLItem, [In] EventFlags lFlags);
		[MethodImpl(MethodImplOptions.InternalCall, MethodCodeType=MethodCodeType.Runtime)]
		void OnSyncUnlock([In, MarshalAs(UnmanagedType.Interface)] IExStoreEventInfo pEventInfo, [In, MarshalAs(UnmanagedType.BStr)] string bstrURLItem, [In] EventFlags lFlags);
	}

	[ComImport, InterfaceType((short) 1), Guid("9DA0E129-86CE-11D1-8699-00C04FB98036")]
	public interface IExStoreNotification
	{
		[MethodImpl(MethodImplOptions.InternalCall, MethodCodeType=MethodCodeType.Runtime)]
		void OnChange([In, ComAliasName("Microsoft.Interop.ExOleDB.ULONG_PTR")] uint dwHandle, [In] uint dwFlags);
	}

	[ComImport, InterfaceType((short) 1), Guid("9DA0E12A-86CE-11D1-8699-00C04FB98036")]
	public interface IExStoreRegisterNotification
	{
		[MethodImpl(MethodImplOptions.InternalCall, MethodCodeType=MethodCodeType.Runtime)]
		void Register([In, MarshalAs(UnmanagedType.BStr)] string bstrURL, [In, MarshalAs(UnmanagedType.Interface)] IExStoreNotification pSink, [In] uint dwFlags, [ComAliasName("Microsoft.Interop.ExOleDB.ULONG_PTR")] out uint pdwHandle);
		[MethodImpl(MethodImplOptions.InternalCall, MethodCodeType=MethodCodeType.Runtime)]
		void UnRegister([In, ComAliasName("Microsoft.Interop.ExOleDB.ULONG_PTR")] uint dwHandle);
		[MethodImpl(MethodImplOptions.InternalCall, MethodCodeType=MethodCodeType.Runtime)]
		void Ready([In, ComAliasName("Microsoft.Interop.ExOleDB.ULONG_PTR")] uint dwHandle, out uint pdwRemaining);
	}

	[ComImport, Guid("9DA0E0FF-86CE-11D1-8699-00C04FB98036"), InterfaceType((short) 1)]
	public interface IExStoreSyncEvents
	{
		[MethodImpl(MethodImplOptions.InternalCall, MethodCodeType=MethodCodeType.Runtime)]
		void OnSyncSave([In, MarshalAs(UnmanagedType.Interface)] IExStoreEventInfo pEventInfo, [In, MarshalAs(UnmanagedType.BStr)] string bstrURLItem, [In] EventFlags lFlags);
		[MethodImpl(MethodImplOptions.InternalCall, MethodCodeType=MethodCodeType.Runtime)]
		void OnSyncDelete([In, MarshalAs(UnmanagedType.Interface)] IExStoreEventInfo pEventInfo, [In, MarshalAs(UnmanagedType.BStr)] string bstrURLItem, [In] EventFlags lFlags);
	}

	[ComImport, InterfaceType((short) 1), Guid("9DA0E101-86CE-11D1-8699-00C04FB98036")]
	public interface IExStoreSystemEvents
	{
		[MethodImpl(MethodImplOptions.InternalCall, MethodCodeType=MethodCodeType.Runtime)]
		void OnTimer([In, MarshalAs(UnmanagedType.BStr)] string bstrURLItem, [In] EventFlags lFlags);
		[MethodImpl(MethodImplOptions.InternalCall, MethodCodeType=MethodCodeType.Runtime)]
		void OnMDBStartUp([In, MarshalAs(UnmanagedType.BStr)] string bstrMDBGuid, [In, MarshalAs(UnmanagedType.BStr)] string bstrMDBName, [In] EventFlags lFlags);
		[MethodImpl(MethodImplOptions.InternalCall, MethodCodeType=MethodCodeType.Runtime)]
		void OnMDBShutDown([In, MarshalAs(UnmanagedType.BStr)] string bstrMDBGuid, [In] EventFlags lFlags);
	}

	[ComImport, Guid("9DA0E0EF-86CE-11D1-8699-00C04FB98036"), InterfaceType((short) 1)]
	public interface IGetLockRow
	{
		[MethodImpl(MethodImplOptions.InternalCall, MethodCodeType=MethodCodeType.Runtime)]
		void GetLockRow([In] ref Guid riid, out uint pdwBindStatus, [MarshalAs(UnmanagedType.IUnknown)] out object ppunkLockRow);
	}

	[ComImport, InterfaceType((short) 1), Guid("9DA0E10B-86CE-11D1-8699-00C04FB98036")]
	public interface IGetSourceURL
	{
		[return: MarshalAs(UnmanagedType.BStr)]
		[MethodImpl(MethodImplOptions.InternalCall, MethodCodeType=MethodCodeType.Runtime)]
		string GetSourceURL();
	}

	[ComImport, Guid("9DA0E10C-86CE-11D1-8699-00C04FB98036"), TypeLibType((short) 0x1040)]
	public interface IStoreGuidFromUrl
	{
		[return: MarshalAs(UnmanagedType.BStr)]
		[MethodImpl(MethodImplOptions.InternalCall, MethodCodeType=MethodCodeType.Runtime), DispId(0x60020000)]
		string StoreGuidFromUrl([In, MarshalAs(UnmanagedType.BStr)] string bstrURL);
	}

	[ComImport, CoClass(typeof(StoreGuidFromUrlClass)), Guid("9DA0E10C-86CE-11D1-8699-00C04FB98036")]
	public interface StoreGuidFromUrl : IStoreGuidFromUrl
	{
	}

	[ComImport, TypeLibType((short) 2), ClassInterface((short) 0), Guid("9DA0E10D-86CE-11D1-8699-00C04FB98036")]
	public class StoreGuidFromUrlClass : StoreGuidFromUrl
	{
		// Methods
		[return: MarshalAs(UnmanagedType.BStr)]
		[MethodImpl(MethodImplOptions.InternalCall, MethodCodeType=MethodCodeType.Runtime), DispId(0x60020000)]
		public virtual extern string StoreGuidFromUrl([In, MarshalAs(UnmanagedType.BStr)] string bstrURL);
	}
}