﻿using System;
using System.IO;
using System.Runtime.InteropServices;
using System.Runtime.Serialization.Formatters.Binary;

namespace InfiniTec.Exchange.Eventing
{
    [Serializable]
    class StateBag
    {
        public bool IsSilentSaveOperation { get; set;}
        
        public object UserState { get; set;}

        public IntPtr SerializeToUnmanagedMememory()
        {
            var formatter = new BinaryFormatter();

            using (var stream = new MemoryStream())
            {
                formatter.Serialize(stream, this);
                stream.Flush();
                return CopyToNativeMemory(stream.ToArray());
            }

        }

        public static StateBag DeserializeFromUnmanagedMemory(IntPtr ptr)
        {
            int length = Marshal.ReadInt32(ptr, 0);
            var buffer = new byte[length];

            Marshal.Copy(ptr, buffer, 0, length);

            Marshal.FreeHGlobal(ptr);

            var formatter = new BinaryFormatter();
            using (var stream = new MemoryStream(buffer))
            {
                stream.Seek(4, SeekOrigin.Begin);
                return (StateBag) formatter.Deserialize(stream);
            }
        }

        private static IntPtr CopyToNativeMemory(byte[] bytes)
        {
            var ptr = Marshal.AllocHGlobal(bytes.Length+4);


            byte[] buffer;

            using (var stream = new MemoryStream())
            using (var writer = new BinaryWriter(stream))
            {
                writer.Write(bytes.Length+4);
                writer.Write(bytes);

                stream.Flush();
                buffer = stream.ToArray();
            }

            Marshal.Copy(buffer, 0, ptr, buffer.Length);

            return ptr;
        }
    }
}
