using System;

namespace InfiniTec.Exchange.Eventing
{
	public class TraceOperation: IDisposable
	{
		private readonly Trace _Trace;

		public TraceOperation(Trace trace, object id)
		{
			if (trace == null) throw new ArgumentNullException("trace");
			if (id == null) throw new ArgumentNullException("id");

			_Trace = trace;
			System.Diagnostics.Trace.CorrelationManager.StartLogicalOperation(id);
		}

		void IDisposable.Dispose()
		{
			System.Diagnostics.Trace.CorrelationManager.StopLogicalOperation();
		}
	}
}