﻿using System.Collections;
using System.ComponentModel;
using System.Configuration.Install;
using InfiniTec.Exchange.Eventing;

namespace TestSink
{
	[RunInstaller(true)]
	public class TestInstaller: Installer
	{
		public override void Commit(IDictionary savedState)
		{
			Initialize();
			base.Commit(savedState);
		}

		public override void Install(IDictionary stateSaver)
		{
			Initialize();
			base.Install(stateSaver);
		}

		public override void Rollback(IDictionary savedState)
		{
			Initialize();
			base.Rollback(savedState);
		}

		public override void Uninstall(IDictionary savedState)
		{
			Initialize();

			base.Uninstall(savedState);
		}

		private void Initialize()
		{
			var url = Context.Parameters["url"] + "/eventsink.evt";

			Context.LogMessage("Binding Url: " + url);
			string criteria = Context.Parameters["Criteria"] ?? string.Empty;
			criteria = criteria.Replace("$", "\"");

			Installers.Add(new EventSinkInstaller<TestSink>
			               	{
			               		Criteria = criteria,
			               		EventMethods = EventMethods.SynchronousEvents,
			               		Scope = MatchScope.Shallow,
			               		Url = url
			               	});
		}
	}
}
